> ## Documentation Index
> Fetch the complete documentation index at: https://docs.coingecko.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Circulating Supply Chart within Time Range by ID

> To query historical circulating supply of a coin, within a range of timestamp based on the provided coin ID

#### Notes

* Accepts ISO date strings (`YYYY-MM-DD` or `YYYY-MM-DDTHH:MM`, recommended) or UNIX timestamps for `from` and `to`.

* Auto-granularity when `interval` is not specified:

  | Date range | Granularity |
  | - | - |
  | 1 day from current time | **5-minutely** |
  | 1 day from any other time | **hourly** |
  | 2–90 days | **hourly** |
  | Above 90 days | **daily** (00:00 UTC) |

* Data available from 22 June 2019 onwards.

> [!NOTE]
>
> The last completed UTC day (00:00) is available 35 minutes after midnight (00:35 UTC).

**Enterprise Only**
This endpoint is exclusively available to **Enterprise** plan.
[→ Contact sales](https://www.coingecko.com/en/api/enterprise)

**Cache / Update Frequency:**

#### SDK Examples

```typescript TypeScript theme={null}
const response = await client.coins.circulatingSupplyChart.getRange('bitcoin', {
  from: '2025-01-01',
  to: '2025-12-31',
});

console.log(JSON.stringify(response, null, 2));
```

```python Python theme={null}
response = client.coins.circulating_supply_chart.get_range(
  "bitcoin",
  from_="2025-01-01",
  to="2025-12-31",
)

print(response.model_dump_json(indent=2))
```


## OpenAPI

````yaml openapi-specs/pro-api.json get /coins/{id}/circulating_supply_chart/range
openapi: 3.0.0
info:
  title: CoinGecko Pro API
  version: 3.0.0
servers:
  - url: https://pro-api.coingecko.com/api/v3
security:
  - headerAuth: []
  - queryAuth: []
paths:
  /coins/{id}/circulating_supply_chart/range:
    get:
      summary: Circulating Supply Chart within Time Range by ID
      description: >-
        To query historical circulating supply of a coin, within a range of
        timestamp based on the provided coin ID
      operationId: coins-id-circulating-supply-chart-range
      parameters:
        - name: id
          in: path
          required: true
          description: |-
            Coin ID. 
            *refers to [`/coins/list`](/reference/coins-list).
          schema:
            type: string
            default: bitcoin
        - name: from
          in: query
          required: true
          description: >-
            Starting date in ISO date string (`YYYY-MM-DD` or
            `YYYY-MM-DDTHH:MM`) or UNIX timestamp. 

            **Use ISO date string for best compatibility.**
          schema:
            type: string
            default: '2025-01-01'
        - name: to
          in: query
          required: true
          description: >-
            Ending date in ISO date string (`YYYY-MM-DD` or `YYYY-MM-DDTHH:MM`)
            or UNIX timestamp. 

            **Use ISO date string for best compatibility.**
          schema:
            type: string
            default: '2025-12-31'
      responses:
        '200':
          description: Historical circulating supply chart data within time range
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CirculatingSupplyChart'
              example:
                circulating_supply:
                  - - 1735689600000
                    - '19803921.0'
                  - - 1735776000000
                    - '19804340.0'
                  - - 1735862400000
                    - '19804871.0'
components:
  schemas:
    CirculatingSupplyChart:
      type: object
      required:
        - circulating_supply
      properties:
        circulating_supply:
          type: array
          description: Circulating supply data points as [timestamp, supply] pairs
          items:
            type: array
            items:
              oneOf:
                - type: number
                - type: string
  securitySchemes:
    headerAuth:
      type: apiKey
      in: header
      name: x-cg-pro-api-key
      description: >-
        Learn how to [set up your API
        key](https://docs.coingecko.com/docs/setting-up-your-api-key)
    queryAuth:
      type: apiKey
      in: query
      name: x_cg_pro_api_key
      description: >-
        Learn how to [set up your API
        key](https://docs.coingecko.com/docs/setting-up-your-api-key)

````

This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.